data Myset a = Myset [a]

instance Show a => Show (Myset a)
  where 
   show (Myset []) = "{ }"
   show (Myset (x:xs)) = "{ "++ show x ++ meat ++" }"
     where meat = concatMap (\x-> ", "++show x ) xs

size :: Myset a -> Int
size (Myset xs) = length xs

belongs :: Eq a => a -> Myset a -> Bool
belongs x (Myset xs) = elem x xs

list2set :: Eq a => [a] -> Myset a
list2set [] = Myset []
list2set (x:xs) = insert x (list2set $ filter (/=x) xs)

set2list :: Myset a -> [a]
set2list (Myset xs) = xs

insert :: Eq a => a -> Myset a -> Myset a
insert x (Myset ys) 
  | belongs x (Myset ys) = Myset ys 
  | otherwise = Myset (x:ys)

subset :: Eq a => Myset a -> Myset a -> Bool
subset (Myset xs) (Myset ys) = and (map (\x -> belongs x (Myset ys)) xs)

union :: Eq a => Myset a -> Myset a -> Myset a
union (Myset xs) s2 = foldr insert s2 xs

intersection :: Eq a => Myset a -> Myset a -> Myset a
intersection (Myset xs) s2 = Myset [ x | x<-xs, belongs x s2 ]

difference :: Eq a => Myset a -> Myset a -> Myset a
-- diff a b = a\b
difference (Myset xs) s2 = Myset [ x | x<-xs, not $ belongs x s2 ]

powerset :: Eq a => Myset a -> Myset (Myset a)
powerset (Myset []) = Myset [(Myset [])]
powerset (Myset (x:xs)) = union (Myset p1) (Myset $ map (insert x) p1)
  where 
   (Myset p1) = powerset (Myset xs)

instance Eq a => Eq (Myset a)
  where
   s1 == s2 = (s1 `subset` s2) && (s2 `subset` s1)
